#!/bin/bash
#此脚本是根据访问端口，获得返回值，从未进行服务的健康性检测。
ip1=`ip addr | grep inet | grep -v "127.0.0.1" | cut -d: -f2| awk '{print $2}' | awk -F "/" '{print $1}'`
port1=$1
user1=$2

if [ ! -d /data/monitor/logs ];then
	mkdir -p /data/monitor/logs
else
	echo "dir exist"
fi
while true;
do
	status=`netstat -an | grep $port1 | grep LISTEN |awk '{print $4}'`
	echo $pid_s
	if [ "$status" = "" ]; then
		date1=`date +%y%m%d-%H:%M:%S`
        	echo "服务器$ip1时间$date1端口$port1不正常"
		#发生报警需要邮件和企业微信告警，需要补充内容
		errlog="服务器$ip1时间$date1端口$port1不正常，请进一步确认"
		echo "$errlog" >>/data/monitor/logs/port-err.log
		#对接企业微信通知
		. /data/monitor/wx_warn.sh
		wx_warn "$errlog" "$user1"
		#对接邮件通知
		echo "$errlog" | mail -s "$errlog" jun_s@yadea.com.cn zhining_q@yadea.com.cn
	else
		date1=`date +%y%m%d-%H:%M:%S`
        	echo "服务器$ip1时间$date1端口$port1正常"
	fi
	sleep 30
done
